Subiject: Refactor findBy API

Description

Sorry for changing the API but | would like to do it before the public release. The main reason is to narrow the API towards what has

Doctrine.

The change affect mainly the findFiltered method which is replaced by findBy according to:
http://www.doctrine-project.org/api/orm/2.3/source-class-Doctrine. ORM.EntityRepository.html#159-171

The patch will also improve MM finding in repository: $repository->findByCategories()

Quite roughly:

Before:

$respository->findFiltered($filter, $order, $offset, $limit)

After:
$respository->findBy($match, $order, $limit, $offset)

Before:
$filter->getConstraint()
S$filter->setConstraint()
$filter->addConstraint()

After (same signature):
$match->getMatches()
$match->setMatches()
$match->addMatches()

Before:
$pager->getltemsPerPage()
$pager->setltemsPerPage()

After (same signature):
$pager->getLimit()
$pager->setLimit()

Related issues:
related to Media Management - Task # 48047: Release Media 1.0.0

Resolved 2013-05-08

Associated revisions

Revision 0dd6cc2c - 2013-05-13 21:57 - Fabien Udriot
http://www.doctrine-project.org/api/orm/2.3/source-class-Doctrine.ORM.EntityRepository.html#159-171

[[FEATURE] Refactor findBy API

This is a breaking change affecting method "findFiltered" which is
replaced by "findBy" according to Doctrine style. On the good side,
the patch also improves MM finding in repository: $repository->findByCategories()

Change-Id: 1192a566f59588942df5cbce6d888027fdc42ca73
Fixes: #47842
Reviewed-on: https://review.typo3.0rg/20432

Reviewed-by: Frans Saris
Tested-by: Frans Saris
Reviewed-by: Fabien Udriot
Tested-by: Fabien Udriot

History

#1 - 2013-05-02 18:23 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.

It is available at https://review.typo3.0rg/20432

#2 - 2013-05-04 19:59 - Frans Saris

Is it with this change posible to query an aditional mm relation that are added to the tca?

For a client project | need to extent sys_file/asset with the posibility to add tags. So | need to implement a new mm relation.
| see the patch is wip, what needs to be done or is still missing? Maybe | can help.

If you plan to change the api, please do it now. Don't wait to long.

When do you want to release a first version?

#3 - 2013-05-04 21:38 - Fabien Udriot

Hi Frans,

Is it with this change posible to query an aditional mm relation that are added to the tca?

That is the goal / idea, indeed.

| see the patch is wip, what needs to be done or is still missing? Maybe | can help.

It is basically finished. Though, | wanted to add some unit tests making sure the "mm" query would work and since | haven't really tested | am
expecting some amendment to the patch. Here an example for Categories but could also work for Tags as long you have TCA configured.

/** @var $match \TYPO3\CMS\Media\QueryElement\Match */
$match = $this->objectManager->get('TYPO3\CMS\Media\QueryElement\Match');
$match->addMatch('categories’, $uidOrObject);
$match->addMatch('categories’, $uidOrObject2);
/** @var $assetRepository \TYPO3\CMS\Media\Domain\Model\AssetRepository */

$assetRepository = $this->objectManager->get('TYPO3\CMS\Media\Domain\Model\AssetRepository');
$assetRepository->findBy($match);

The same should work for findByCategories - or findByTags from your example:

/** @var $assetRepository \TYPO3\CMS\Media\Domain\Model\AssetRepository */
$assetRepository = $this->objectManager->get('TYPO3\CMS\Media\Domain\Model\AssetRepository');
$assetRepository->findByCategories($uidOrObject);

It is a "difficult”" patch to get into but if you have time helping / making sure the feature is there, it would be awesome. | could merge the others patches

if it helps apply the change set easier. Let me know.

When do you want to release a first version?

The soonest as possible. | think we have a decent set of features making it usable for a daily life use. However, before doing so, | would like merging

the remaining patches pending in Gerrit as well as this critical one.

#4 - 2013-05-05 00:05 - Frans Saris

| wil have a look at it monday.

The critical patch | reviewed and tested already now hope a core dev has a look at it. For the others | wil make some time monday or you must 100%

be sure they are ok :)

#5 - 2013-05-06 07:54 - Fabien Udriot

Actually, if you would like to have another MM relation than categories working for the findBy method (see example above) you probably have to
change a few things. The current implementation is a special case for categories but should not be too difficult to extend.

In EXT:media/Classes/QueryElement/Query.php, consider updating getClauseCategories to getClauseMM and around line 205 replace the if (!

empty($matches['categories'])) by
$matches = $this->match->getMatches();
foreach ($this->match->getMatches() as $field => $value) {

if ($this->tcaFieldService->hasRelationManyToMany($field)) {
/I here the rest with some modification...

#6 - 2013-05-06 08:51 - Fabien Udriot

2015-08-04 3/5


https://review.typo3.org/#/q/status:open+project:TYPO3v4/Extensions/media,n,z
https://review.typo3.org/#/q/status:open+project:TYPO3v4/Extensions/media,n,z
http://forge.typo3.org/issues/47782

A last thing: there is a bit of confusion with method naming with getClauseCategories, getClauseSearch, getClauseConstraints which all have the same

purpose. Don't worry, | will rename them. There are private methods anyway.

#7 - 2013-05-06 11:07 - Frans Saris

Oke, will look into that.

Maybe you can help me on an other thing. What's the easiest/best way to preform a LIKE query on the asset repository?

| need something like:

SELECT * FROM..... Where sys_file.identifier LIKE '/sample_data_map/%'

#8 - 2013-05-06 11:59 - Fabien Udriot

Not tested code:

/** @var $match \TYPO3\CMS\Media\QueryElement\Match */
$match = $this->objectManager->get('TYPO3\CMS\Media\QueryElement\Match');
$match->setSearchTerm('foo');

/** @var $assetRepository \TYPO3\CMS\Media\Domain\Model\AssetRepository */

$assetRepository = $this->objectManager->get('TYPO3\CMS\Media\Domain\Model\AssetRepository');
$assetRepository->findBy($match);

#9 - 2013-05-06 19:56 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.

It is available at https://review.typo3.0rg/20432

#10 - 2013-05-08 10:42 - Frans Saris
- Status changed from New to Accepted

#11 - 2013-05-11 19:43 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/20432

#12 - 2013-05-13 22:36 - Fabien Udriot
- Status changed from Accepted to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:0dd6cc2cf43cc248564411141ee4d1bc8caald013.
